SystemOrganization addCategory: #Geometry!
SystemOrganization addCategory: 'Geometry-Test'!

!Point methodsFor: '*Geometry' stamp: 'NataliaTymchuk 7/7/2014 12:39'!
ray: aPoint 
	^ GRay origin: self direction: aPoint ! !

!Point methodsFor: '*Geometry' stamp: 'NataliaTymchuk 7/6/2014 23:34'!
segment: aPoint 
	^ GSegment with: self with: aPoint ! !

!Point methodsFor: '*Geometry' stamp: 'NataliaTymchuk 7/6/2014 23:50'!
signFuz
	^ (x signFuz @ y signFuz)! !

!Number methodsFor: '*Geometry' stamp: 'NataliaTymchuk 7/6/2014 23:50'!
signFuz
	"Answer 1 if the receiver is greater than 0, -1 if less than 0, else 0."

	self >~ 0 ifTrue: [ ^  1 ].
	self <~ 0 ifTrue: [ ^ -1 ].
	^ 0! !

TestCase subclass: #GCircleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/28/2014 11:42'!
testBoundaryContains
	self
		assert: ((GCircle  center: 2 @ 2 radius: 3) boundaryContains: 2 @ 2)
		equals: false! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/28/2014 11:42'!
testBoundaryContains1
	self
		assert: ((GCircle  center: 2 @ 2 radius: 3) boundaryContains: 5 @ 2)
		equals: true! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/20/2014 18:44'!
testBoundaryContainsThis
	self
		assert: ((GCircle  center: 2 @ 2 radius: 3) boundaryContainsThis: { 2 @ 2 . 5 @ 2 })
		equals: true! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/20/2014 18:40'!
testBoundaryContainsWhich
	self
		assert: ((GCircle  center: 2 @ 2 radius: 3) boundaryContainsWhichOf: { 2 @ 2 . 5 @ 2 })
		equals: {5 @ 2}! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/28/2014 11:42'!
testContains
	self
		assert: ((GCircle  center: 2 @ 2 radius: 3) contains: 2 @ 2)
		equals: true! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/28/2014 11:42'!
testContains1
	self
		assert: ((GCircle  center: 2 @ 2 radius: 3) contains: 6 @ 2)
		equals: false! !

!GCircleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/20/2014 18:03'!
testPolygonOn
	self
		assert: (((GCircle  center: 1 @ 1 radius: 3) polygonOn: { -20 @ 10 ". 10 @ 40" . 40 @ 10 . 10 @ -20 }) at:1 )v1
		equals: -20 @ 10! !

TestCase subclass: #GLineTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/11/2014 15:13'!
testEquel
self
	assert: ((GLine a:1 b:1 c: -13)= (GLine a:6 b:6 c: -78))
	equals: true.
self
	assert: ((GLine a:0 b:1 c: -13)= (GLine a:0 b:6 c: -78))
	equals: true.
self
	assert: ((GLine a:1 b:1 c: -13)= (GLine a:1 b:6 c: -78))
	equals: false.
self
	assert: ((GLine a:1 b:1 c: -13)= (GLine a:6 b:6 c: -7))
	equals: false.
self
	assert: ((GLine a:1 b:0 c: -13)= (GLine a:6 b:0 c: -78))
	equals: true.
self
	assert: ((GLine a:0 b:1 c: 0)= (GLine a:0 b:6 c: 0))
	equals: true.
self
	assert: ((GLine a:1 b:0 c: 0)= (GLine a:1 b:0 c: 0))
	equals: true.
	! !

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 17:24'!
testIntersect
self
	assert: ((GLine a: 2 b: -3 c: 0.5) intersect: (GLine a: 1 b: 1 c: -2))
	equals: 1.1 @ 0.9! !

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 17:37'!
testIntersect1
self
	assert: ((GLine a: 2 b: -3 c: 0.5) intersect: (GLine a: -2 b: -2 c: 4))
	equals: 1.1 @ 0.9! !

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/12/2014 20:22'!
testParallelTo
self
	assert: ((GLine a: 0 b: -3 c: 0.5) parallelTo: (GLine a: -2 b: 0 c: 4))
	equals: false.
self
	assert: ((GLine a: 0 b: -3 c: 0.5) parallelTo: (GLine a: -2 b: 1 c: 4))
	equals: false.
self
	assert: ((GLine a: 1 b: 2 c: 0.5) parallelTo: (GLine a: 2 b: 4 c: 4))
	equals: true.
self
	assert: ((GLine a: 0 b: 2 c: 0.5) parallelTo: (GLine a: 0 b: 2 c: 0.5))
	equals: true.! !

!GLineTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 15:17'!
testСutWith
	self
		assert: ((GLine a: -20  b: 30  c: -500 ) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v1
		equals: (-15@(20/3)).
	self
		assert: ((GLine a: -20  b: 30  c: -500 ) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v2
		equals: ((-5/2)@15).	
	self
		assert: ((GLine a: -30  b: 50  c: -900 ) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v1 
		equals: (-15 @ 9) .	
	self
		assert: ((GLine a: -30  b: 50  c: -900 ) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v2 
		equals: (-5 @ 15).
	self
		assert: ((GLine a: 0  b: 1  c: -25 ) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 ))
		equals: nil.	! !

TestCase subclass: #GPolygonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GPolygonTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 21:10'!
testConvexHullOn
self
	assert: ((GPolygon convexHullOn:{ 0 @ -20 . 0 @ 10 . 30 @ -30 . 40 @ 0 . -10 @ 0 . 40 @ -20 } ) vertices )
	equals:{ -10 @ 0 . 0 @ -20 . 30 @ -30 . 40 @ -20 . 40 @ 0 . 0 @ 10 } asOrderedCollection! !

!GPolygonTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 21:11'!
testConvexHullOn1
self
	assert: ((GPolygon convexHullOn:{ 0 @ -20 . 0 @ 10 . 30 @ -30 . 0 @ 0 . 40 @ 0 . -10 @ 0 . 40 @ -20 } ) vertices )
	equals:{ -10 @ 0 . 0 @ -20 . 30 @ -30 . 40 @ -20 . 40 @ 0 . 0 @ 10 } asOrderedCollection! !

TestCase subclass: #GRayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GRayTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 11:29'!
testFlipped
	self
		assert: ((GRay origin: 100 @ 100 direction: 80 @ 110) flipped )direction
		equals: 120 @ 90.
	self
		assert: ((GRay origin: 100 @ 100 direction:  120 @ 90) flipped )direction
		equals: 80 @ 110! !

!GRayTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 11:29'!
testHasPoint
	self
		assert: ((GRay origin: 100 @ 100 direction: 80 @ 110) hasPoint: 120 @ 90)
		equals: false.
	self
		assert: ((GRay origin: 100 @ 100 direction: 120 @ 90) hasPoint: 120 @ 90)
		equals: true.
	self
		assert: ((GRay origin: 100 @ 100 direction: 120 @ 90) hasPoint: 100 @ 100)
		equals: true.
	self
		assert: ((GRay origin: 100 @ 100 direction: 110 @ 110) hasPoint: 150 @ 150)
		equals: true.	! !

!GRayTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 11:29'!
testСutWith
	self
		assert: ((GRay origin: -10 @ 10 direction: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v1
		equals: (-5/2)@15.
	self
		assert: ((GRay origin: -10 @ 10 direction: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v2
		equals: -10 @ 10.	
	self
		assert: ((GRay origin: -30 @ 0 direction: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v1 
		equals: (-15 @ 9) .	
	self
		assert: ((GRay origin: -30 @ 0 direction: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v2 
		equals: (-5 @ 15).
	self
		assert: ((GRay origin: -30 @ 30 direction: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 ))
		equals: nil.	! !

TestCase subclass: #GRectangleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GRectangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/30/2014 22:07'!
testHasOnBoundary
	self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) hasOnBoundary: 1 @ 3)
   		equals: true.
	self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) hasOnBoundary: 2 @ 3)
   		equals: true.
	self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) hasOnBoundary: 0 @ 0)
   		equals: false.! !

!GRectangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/23/2014 17:00'!
testHasOnOneSideAnd

self 
	assert:((Rectangle origin: -22 @ -42 corner: 62 @ 42) hasOnOneSide: -9 @ 42 and: 30 @ 42)
	equals: true. 
self 
	assert:((Rectangle origin: -22 @ -42 corner: 62 @ 42) hasOnOneSide: -22 @ 30 and: -22 @ -10)
	equals: true. 
self 
	assert:((Rectangle origin: -22 @ -42 corner: 62 @ 42) hasOnOneSide: -9 @ 42 and: -22 @ -10)
	equals: false. ! !

!GRectangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/23/2014 11:32'!
testHasPoint
	self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) hasPoint: 1 @ 3)
   		equals: true.
	self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) hasPoint: 2 @ 1)
   		equals: true.
	self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) hasPoint: 0 @ 0)
   		equals: false.! !

!GRectangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 11:52'!
testIntersectionPointsWith
 	self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) intersectionPointsWithLine: ((GSegment with: 0 @ 					3 with: 4 @ 1) asLine))
		  equals: { 1 @ 2.5 . 3 @ 1.5 }! !

!GRectangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/23/2014 15:15'!
testSideWhichHas

self assert:((Rectangle origin:  1 @ 3 corner: 3 @ 0) sideWhichHas: 1 @ 2.5)
	equals: (GSegment with: 1 @ 3 with: 1 @ 0)  ! !

TestCase subclass: #GSegmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 18:02'!
testAsLine
|line|
	line := (GSegment with:  1 @ 3 with: 3 @ 0) asLine .
	self assert: line a equals: 3.
	self assert: line b equals: 2.
	self assert: line c equals: -9.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:25'!
testAsLine1
|line|
	line := (GSegment with:  -2 @ 4 with: 2 @ 4) asLine .
	self assert: line a equals: 0.
	self assert: line b equals: 1.
	self assert: line c equals: -4.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 18:05'!
testAsLine2
|line|
	line := (GSegment with:  1 @ 3 with: 1 @ 0) asLine .
	self assert: line a equals: 1.
	self assert: line b equals: 0.
	self assert: line c equals: -1.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:24'!
testBelowPoint
self assert:((GSegment with:  -2 @ 4 with: 2 @ 4) belowPoint: -2 @ 4 ) 
	equals: false.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:28'!
testBelowPoint1

self assert:((GSegment with:  -2 @ 4 with: 2 @ 4) belowPoint: 0 @ 5 ) 
	equals: true.
self assert:((GSegment with:  -2 @ 4 with: 2 @ 4) belowPoint: 0 @ -5 ) 
	equals: false.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:46'!
testBelowPoint2
self assert:((GSegment with:  -2 @ 4 with: -2 @ 0) belowPoint: 0 @ 2 ) 
	equals: true.
self assert:((GSegment with:  -2 @ 4 with: -2 @ 0) belowPoint: -4 @ 2 ) 
	equals: false.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:16'!
testHasPoint

	self assert:((GSegment with:  1 @ 3 with: 3 @ 0) hasPoint: 1 @ 3)
   		equals: true.
	self assert:((GSegment with:  1 @ 3 with: 3 @ 0) hasPoint: 3 @ 0)
   		equals: true.
	self assert:((GSegment with:  -1 @ 1 with: 1 @ -1) hasPoint: 0 @ 0)
   		equals: true.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/23/2014 15:39'!
testIntersect
	self
		assert: ((GSegment with: -1 @ -1 with: 1 @ 1) = (GSegment with: 1 @ 1 with: -1 @ -1))
		equals: true.
	self
		assert: ((GSegment with: -1 @ -1 with: 1 @ 1) = (GSegment with: -1 @ 1 with: -1 @ 1))
		equals: false.	! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 16:19'!
testIntersect1
	self
		assert: ((GSegment with: -1 @ -1 with: 1 @ 1) intersect:(GSegment with: -3 @ 3 with: -1 @ 1))
		equals: nil! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 11:31'!
testIntersectionPointWithVector
	self
		assert: ((GSegment with: 2 @ 0 with: 2 @ 3) intersectionPointWithRay: (GRay origin: 0 @ 0  direction:  3 @ 2))
		equals: 2 @ (4/3).
	self
		assert: ((GSegment with: 2 @ 0 with: 2 @ 3) intersectionPointWithRay: (GRay origin: 0 @ 0  direction:  1 @ 1))
		equals: 2 @ 2.	
	self
		assert: ((GSegment with: -2 @ 0 with: -2 @ 3) intersectionPointWithRay: (GRay origin: 0 @ 0  direction:  1 @ 1))
		equals: nil.
	self
		assert: ((GSegment with: 0 @ 0 with: 0 @ 3) intersectionPointWithRay: (GRay origin: 0 @ 0  direction:  1 @ 1))
		equals: 0 @ 0.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:48'!
testLength
	self
		assert: (GSegment with: 0 @ 0 with: 3 @ 4) length
		equals: 5! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/22/2014 16:20'!
testLength1
	self
		assert: (GSegment with: -2 @ 1 with: 3 @ 4) length
		equals: 34 sqrt! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/21/2014 12:49'!
testMidPoint
	self
		assert: (GSegment with: -1 @ 2 with: 2 @ 1) midPoint 
		equals: 0.5 @ 1.5! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/22/2014 16:21'!
testMidPoint1
	self
		assert: (GSegment with: 2 @ 1 with: 2 @ 1) midPoint 
		equals: 2 @ 1! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 16:58'!
testPerpendicularBisector
	self
		assert: (GSegment with: -1 @ 2 with: 0 @ 0) perpendicularBisector a
		equals: 1! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 17:33'!
testPerpendicularBisector1
|line|
	line := (GSegment with: 1 @ 3 with: -1 @ 1) perpendicularBisector. 
		self assert: line a equals: -2.
		self assert: line b equals: -2.
		self assert: line c equals: 4.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 16:58'!
testPerpendicularBisector2
	self
		assert: (GSegment with: -1 @ 2 with: 0 @ 0) perpendicularBisector b
		equals: -2! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 17:36'!
testPerpendicularBisector3
|line|
	line := (GSegment with: 3 @ 0 with: 1 @ 3)  perpendicularBisector. 
		self assert: line a equals: -2.
		self assert: line b equals: 3.
		self assert: line c equals: -1/2.! !

!GSegmentTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 14:57'!
testСutWith
	self
		assert: ((GSegment with: -10 @ 10 with: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v1
		equals: (-5/2)@15.
	self
		assert: ((GSegment with: -10 @ 10 with: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v2
		equals: -10 @ 10.	
	self
		assert: ((GSegment with: -30 @ 0 with: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v1 
		equals: (-15 @ 9) .	
	self
		assert: ((GSegment with: -30 @ 0 with: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 )) v2 
		equals: (-5 @ 15).
	self
		assert: ((GSegment with: -30 @ 30 with: 20 @ 30) cutWith: (Rectangle origin: -15 @ 0 corner: 15 @ 15 ))
		equals: nil.	! !

TestCase subclass: #GTriangleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry-Test'!

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:51'!
testArea
	self
		assert:
			((GTriangle with: 0 @ 0 with: 2 @ 0 with: 0 @ 2) area closeTo: 2)! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/22/2014 16:21'!
testCircumscribedCircle
	| circle |
	circle := (GTriangle with: -1 @ 2 with: 0 @ 0 with: 2 @ 1) circumscribedCircle.
	self assert: circle center equals: 0.5 @ 1.5.
	self assert: (circle radius closeTo: 10 sqrt / 2)
	

! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 19:06'!
testCircumscribedCircle1
	| circle |
	circle := (GTriangle with: -1 @ 1 with: 3 @ 0 with: 1 @ 3) circumscribedCircle.
	self assert: circle center equals: (11/10) @ (9/10).
	self assert: (circle radius closeTo: (1+(21*21)) sqrt / 10)
	

! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/11/2014 21:55'!
testCircumscribedCircle2
	| circle |
	circle := (GTriangle with: -1 @ 1 with: 2 @ 3  with: 5 @ -3) circumscribedCircle.
	self assert: circle center equals: (9 / 4) @ (-5 / 8).
	self assert: (circle radius closeTo: (5 sqrt)* 13 / 8 )
! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/12/2014 20:30'!
testCircumscribedCircle3
	| circle |
	circle := (GTriangle with: 2 @ 3 with: 7 @ 4 with: 5 @ 7) circumscribedCircle.
	self assert: circle center equals: (147/34) @ (149/34).

	

! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/26/2014 21:45'!
testIsDegenerate
	self
		assert: (GTriangle with: 0 @ 0 with: 2 @ 0 with: 3 @ 0) isDegenerate.
	self
		assert: (GTriangle with: 0 @ 0 with: 2 @ 0 with: 0 @ 3) isDegenerate not.
	self
		assert: (GTriangle with: 1 @ 0 with: 1 @ 2 with: 1 @ -1) isDegenerate.	! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:41'!
testPerimeter
	self
		assert: (GTriangle with: 0 @ 0 with: 2 @ 0 with: 0 @ 2) perimeter
		equals: 4 + 8 sqrt! !

!GTriangleTest methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:41'!
testSemiperimeter
	self
		assert: (GTriangle with: 0 @ 0 with: 2 @ 0 with: 0 @ 2) semiperimeter
		equals: 2 + 2 sqrt! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/19/2014 17:06'!
edges
	^ { 
		GSegment with: (self origin ) with: (self origin x @ self corner y). 
		GSegment with: (self origin x @ self corner y) with: (self corner).
		GSegment with: (self corner ) with: (self corner x @ self origin y).
 		GSegment with: (self corner x @ self origin y) with: (self origin).
}
! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/30/2014 22:06'!
hasOnBoundary: point
| a |
	a := self edges select: [:edge | a := edge hasPoint: point].
	^a isNotEmpty! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/23/2014 16:59'!
hasOnOneSide: point1 and: point2 
 ^	
	((point1 x = point2 x and:[point1 x = self origin x or:[point1 x = self corner x]] )
or:[point1 y = point2 y and:[point1 y = self origin y or:[point1 y = self corner y]] ])! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/27/2014 21:40'!
hasPoint: point 
"inside the frame and on the boundary"
 ^	((self origin x <= point x and: [point x <= self corner x])
	and:[ (self origin y <= point y and: [point y <= self corner y]) 
	or:[self origin y >= point y and: [point y >= self corner y]]])
	or:
	[(self origin x >= point x and: [point x >= self corner x ])
	and:[ (self origin y <= point y and: [point y <= self corner y]) 
	or:[self origin y >= point y and: [point y >= self corner y]]]
	]! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/27/2014 11:52'!
intersectionPointsWithLine: line

^ self edges collect:[ :edge | edge intersectionPointWithLine: line]  
				thenReject: #isNil.
	! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/27/2014 11:53'!
intersectionPointsWithSegment: segm

^ self edges collect:[ :edge | edge intersectionPointWithSegment: segm]  
				thenReject: #isNil.
	! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 6/19/2014 20:23'!
sideWhichHas: point
	
	^ self edges detect: [ :edge | edge hasPoint: point ]
! !

!Rectangle methodsFor: '*Geometry' stamp: 'NataliaTymchuk 7/6/2014 23:13'!
vertices

	^ { origin . 
		origin x @ corner y . 
		corner. 
		corner x @ origin y }! !

Object subclass: #GCircle
	instanceVariableNames: 'center radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry'!

!GCircle commentStamp: 'NataliaTymchuk 6/27/2014 21:12' prior: 0!
I am a circle. I have a center in (cx, cy) and radius. My equation is: 
(x-cx)^2  + (y-cy)^2 = radius^2 or 
a * (x^2) + a * (y^2) + d * x + e * y + f = 0 
!

!GCircle class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/20/2014 10:49'!
center: aPoint1 radius: aNumber
	^ self new initializeWithCenter: aPoint1 radius: aNumber! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/9/2014 18:20'!
boundaryContains:aPoint
^(self radius = (self center dist: aPoint)) 
! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/20/2014 18:44'!
boundaryContainsThis: points

 ^(points select:[ :point| self boundaryContains: point]) isNotEmpty 
! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/20/2014 18:40'!
boundaryContainsWhichOf: points
 ^ points select:[ :point| self boundaryContains: point]
! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/20/2014 10:50'!
center

^center ! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/9/2014 18:20'!
contains:aPoint
^ (self radius > (self center dist: aPoint)) ! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/20/2014 10:48'!
initializeWithCenter: aPoint1 radius: aNumber
	super initialize.
	center := aPoint1.
	radius := aNumber.! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/20/2014 18:16'!
polygonOn: points
|polygonSegm firstP notUsedPoints currentP|
	currentP := points anyOne.
	firstP := currentP.
	notUsedPoints := points asOrderedCollection remove: currentP; yourself.
	polygonSegm := OrderedCollection new.
	
	[ notUsedPoints isNotEmpty ] whileTrue: [
		| nextP |
		nextP := notUsedPoints detectMin: [ :point | point dist: currentP ].
		polygonSegm add:( GSegment with: currentP with: nextP).
		currentP := nextP.
		notUsedPoints remove: currentP ].
	polygonSegm add:( GSegment with: currentP with: firstP).
	^ polygonSegm! !

!GCircle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/20/2014 10:51'!
radius

^radius ! !

Object subclass: #GLine
	instanceVariableNames: 'a b c'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry'!

!GLine commentStamp: 'NataliaTymchuk 5/21/2014 11:34' prior: 0!
A GLine has 3 instance variables, which are koeficients  of line:
ax+by+c=0

!

!GLine class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/21/2014 11:33'!
a: aNumber1 b: aNumber2 c: aNumber3
	^ self new initializeWithA: aNumber1 b: aNumber2 c: aNumber3! !

!GLine class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/11/2014 17:33'!
through: aPoint1 and: aPoint2
|ai bi ci|
(aPoint1 y) = (aPoint2 y) ifTrue:
[ ^ GLine
		a: 0 b: 1 c: ((aPoint1 y) negated)].
(aPoint1 x) = (aPoint2 x) ifTrue:[ 
	^ GLine
		a: 1 b: 0 c: ((aPoint1 x) negated)].	
ai := (aPoint1 y) - (aPoint2 y). 
bi := (aPoint2 x) - (aPoint1 x).
ci := ((aPoint1 x) - (aPoint2 x)) * (aPoint1 y) + ( ((aPoint2 y) - (aPoint1 y)) * (aPoint1 x) ).
^ self	 a:ai b: bi c: ci! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/11/2014 17:09'!
= line 
^(self a asFloat = line a asFloat and:[self b asFloat = line b asFloat and: [ self c asFloat = line c asFloat]])  
or:
[ (line a ~= 0 and: [line b ~= 0 and: [line c ~= 0]]) 
	ifTrue: [ (self a/ line a ) asFloat = (self b/ line b )asFloat and:[(self b/ line b ) asFloat = (self c/ line c ) asFloat] ]
	ifFalse:[(line a ~= 0 and:[line c ~= 0])
		ifTrue:[ (self a/ line a ) asFloat = (self c/ line c ) asFloat]
		ifFalse:[(line b ~= 0 and:[line c ~= 0])
			ifTrue:[(self b/ line b ) asFloat = (self c/ line c ) asFloat ] 
			ifFalse:[(line a ~= 0 and:[line b ~= 0])
				ifTrue:[(self a/ line a ) asFloat= (self b/ line b ) asFloat ] 
				ifFalse:[(line a = 0 and:[line c = 0])or:[(line b = 0 and:[line c = 0])]
					]
				] 
			]]
	]
! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/21/2014 11:32'!
a
	^a
! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/6/2014 22:55'!
asLine
	^ self ! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/20/2014 10:46'!
b
	^b
! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/21/2014 11:32'!
c
	^c
! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/6/2014 22:56'!
cutWith: frame
| coll |
coll := OrderedCollection new.
frame edges
	collect: [ :edge | edge intersectionPointWithLine: self ]
	thenDo: [ :p |
		(p notNil and: [ coll noneSatisfy: [ :p2 | p2 =~ p ] ])
			ifTrue: [ coll add: p ] ] .
coll isEmpty
	ifTrue:  [ ^ nil ]
	ifFalse: [ ^ GSegment with: coll first with: coll second ]
					
! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/6/2014 21:39'!
hasPoint: aPoint

	^ a * aPoint x + (b * aPoint y) + c =~ 0! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/11/2014 15:05'!
hash
^( a hash  + b hash + c hash ) hashMultiply
! !

!GLine methodsFor: 'initialization' stamp: 'NataliaTymchuk 5/21/2014 11:33'!
initializeWithA: aNumber1 b: aNumber2 c: aNumber3
	super initialize.
	a := aNumber1.
	b := aNumber2.
	c := aNumber3.! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/12/2014 20:18'!
intersect: aGLine 
	| xi yi |

	(self parallelTo: aGLine) ifTrue: [ ^ nil ].
					
	yi := (self c * (aGLine a) - (self a * (aGLine c)))
			/ 
			(self a * (aGLine b) - (self b * (aGLine a))).

	xi := self a isZero
		ifTrue: [
			 ( aGLine b * yi + (aGLine c)) negated / (aGLine a)]
		ifFalse: [
			 ( self b * yi + self c) negated / self a].
	
	^xi@yi.



! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/12/2014 20:18'!
parallelTo: aLine

	^ (self a isZero & aLine a isZero) or:
	[ (self b isZero & aLine b isZero) or:
	[ (aLine a isZero | aLine b isZero) not and:
	[ (self a / aLine a) = (self b / aLine b) ] ] ]! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/6/2014 21:52'!
pointsWithDist: aNumber to: aPoint
	| deltaX delta |
	
	(self hasPoint: aPoint) ifFalse: [
		Error signal: 'This line does not contain ', aPoint asString ].

	b = 0 ifTrue: [
		^ { aPoint + (0 @ aNumber) . aPoint - (0 @ aNumber) } ].
	
	deltaX := aNumber / ((a / b) squared + 1) sqrt.		
	delta := deltaX @ (deltaX * a / b) negated.

	^ { aPoint + delta . aPoint - delta }
	! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/11/2014 15:39'!
printOn: aStream
	a printOn: aStream.
	aStream nextPutAll: 'x '.
	b sign >= 0 ifTrue: [ 
		aStream nextPut: $+ ].
	b printOn: aStream.
	aStream nextPutAll: 'y '.
	c sign >= 0 ifTrue: [ 
		aStream nextPut: $+ ].
	c printOn: aStream.
	aStream nextPutAll: ' = 0'.
	! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 22:27'!
xFor: anY

	^ ((anY * b + c) / a) negated! !

!GLine methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 22:27'!
yFor: anX

	^ ((anX * a + c) / b) negated! !

Object subclass: #GPolygon
	instanceVariableNames: 'vertices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry'!

!GPolygon commentStamp: 'NataliaTymchuk 6/27/2014 21:14' prior: 0!
I'm polygon builded on my vertices.

!

!GPolygon class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 21:10'!
convexHullOn: aCollection
	| lastPoint nextPoint convexHull |

	
	convexHull := OrderedCollection new.
	
	nextPoint := aCollection detectMin: #x.
	
	 [

		lastPoint := nextPoint.
		convexHull add: lastPoint.
		nextPoint := aCollection detect: [ :point | point ~= lastPoint ].

		(aCollection copyWithout: nextPoint) do: [ :point |
			| turn |
			
			turn :=
				(nextPoint x - lastPoint x) * (point y - lastPoint y) -
				((point x - lastPoint x) * (nextPoint y - lastPoint y)).
				
			(turn < 0 or:
				[ turn = 0 and:
				[ (lastPoint dist: point) > (lastPoint dist: nextPoint) ] ]) ifTrue:
					[ nextPoint := point ] ] ] doWhileTrue: [
				convexHull first ~= nextPoint ].
		
	^ self newVertices: convexHull
				! !

!GPolygon class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 20:03'!
newVertices: aCollection
	
	^ self new
		initializeVertices: aCollection;
		yourself.! !

!GPolygon methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 20:03'!
initializeVertices: aCollection
	self initialize.
	
	vertices := aCollection ! !

!GPolygon methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 20:03'!
vertices
	
	^ vertices! !

Object subclass: #GRay
	instanceVariableNames: 'origin direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry'!

!GRay commentStamp: 'NataliaTymchuk 6/27/2014 21:12' prior: 0!
I am a vector builded on line ax+by+c=0 and have my start in point v1.

!

!GRay class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 23:02'!
origin: aPoint1 direction: aPoint2
	^ self new initializeWithOrigin: aPoint1 direction: aPoint2! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 11:32'!
= aRay

^ self origin = aRay origin and: [
 (self origin bearingToPoint: self direction) =
 (aRay origin bearingToPoint: aRay direction) ]
! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 11:21'!
asLine
|ai bi ci|
(self origin  y) = (self direction  y) ifTrue:
[ ^ GLine
		a: 0 b: 1 c: ((self origin y) negated)].
(self origin x) = (self direction x) ifTrue:[ 
	^ GLine
		a: 1 b: 0 c: ((self origin x) negated)].	
ai := (self origin y) - (self direction y). 
bi := (self direction x) - (self origin x).
ci := ((self origin x) - (self direction x)) * (self origin y) + ( ((self direction y) - (self origin y)) * (self origin x) ).
^ GLine
		a:ai b: bi c: ci
! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 11:31'!
cutWith: frame
| coll |
coll := OrderedCollection new.
frame edges
	collect: [ :edge | edge intersectionPointWithRay: self ]
	thenDo: [ :p |
		(p notNil and: [ coll noneSatisfy: [ :p2 | p2 =~ p ] ])
			ifTrue: [ coll add: p ] ] .
coll isEmpty ifTrue:[^ nil]
				 ifFalse:[coll size = 2 
					ifTrue:  [ ^GSegment with: coll first with: coll second ]
					ifFalse: [ ^GSegment with: coll first with: self origin ] ]! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 11:21'!
direction
	^direction 
! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 11:29'!
flipped

	^ GRay origin: self origin direction: (origin + (origin - direction))
! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/6/2014 23:47'!
hasPoint: aPoint
^ (( origin - direction ) signFuz = ( origin - aPoint ) signFuz  or:
					[ origin = aPoint ])
 
! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/7/2014 12:35'!
hash
	^ ( self origin hash hashMultiply +
		(self origin bearingToPoint: self direction) hash ) hashMultiply
! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 13:31'!
initializeWithOrigin: aPoint1 direction: aPoint2
	super initialize.
	origin  := aPoint1.
	direction  := aPoint2 
! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 20:47'!
length
	^ direction dist: origin
! !

!GRay methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/2/2014 11:20'!
origin 
	^origin
! !

Object subclass: #GSegment
	instanceVariableNames: 'v1 v2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry'!

!GSegment commentStamp: 'NataliaTymchuk 5/15/2014 19:46' prior: 0!
I am a segment between two vertices!

!GSegment class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:46'!
with: aPoint1 with: aPoint2
	^ self new initializeWith: aPoint1 with: aPoint2! !

!GSegment methodsFor: 'initialization' stamp: 'NataliaTymchuk 6/23/2014 18:53'!
= segment

^
((self v1 =~ segment v1) and: [self v2 =~ segment v2]) 
or: 
[(self v1 =~ segment v2) and: [self v2 =~ segment v1]]! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 7/11/2014 17:33'!
asLine
	^ GLine through: v1 and: v2! !

!GSegment methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/17/2014 15:25'!
belowPoint:p
^( (self v2 x - self v1 x)*(p y - self v1 y)-((self v2 y - self v1 y)*(p x - self v1 x))> 0 )
	
! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 6/15/2014 17:56'!
boundBy: aPoint
	^ self v1 = aPoint or: [ self v2 = aPoint ]! !

!GSegment methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/6/2014 22:56'!
cutWith: frame
| coll |
coll := OrderedCollection new.
frame edges
	collect: [ :edge | edge intersectionPointWithSegment: self ]
	thenDo: [ :p |
		(p notNil and: [ coll noneSatisfy: [ :p2 | p2 =~ p ] ])
			ifTrue: [ coll add: p ] ].
coll ifEmpty: [ "self halt".
	(frame hasPoint: self v1)
		ifTrue:  [ ^ self ]
		ifFalse: [ ^ nil ] ].

coll size = 2 
	ifTrue: [ ^ GSegment with: coll first with: coll second ].

(frame hasPoint: self v1) 
	ifTrue:  [ ^ GSegment with: coll first with: self v1 ] 
	ifFalse: [ ^ GSegment with: coll first with: self v2 ]
							
	
! !

!GSegment methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/30/2014 21:33'!
doesntHave: points betweenItselfAnd: segm
	
! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 6/23/2014 18:46'!
hasPoint:aPoint

  ^( (self v1 x <=~ aPoint x and: [aPoint x <=~ self v2 x])  or:
		[self v2 x <=~ aPoint x and: [aPoint x <=~ self v1 x]]  ) and: 
   [ (self v1 y <=~ aPoint y and: [aPoint y <=~ self v2 y])  or:
		[self v2 y <=~ aPoint y and: [aPoint y <=~ self v1 y]]   ]  .
   
! !

!GSegment methodsFor: 'initialization' stamp: 'NataliaTymchuk 6/12/2014 16:04'!
hash
^( v1 hash  + v2 hash ) hashMultiply! !

!GSegment methodsFor: 'initialization' stamp: 'NataliaTymchuk 5/15/2014 19:46'!
initializeWith: aPoint1 with: aPoint2
	super initialize.
	v1 := aPoint1.
	v2 := aPoint2! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 6/17/2014 16:42'!
intersect:aSegment

(self v1 to: self v2 intersects: aSegment v1 to: aSegment v2) 
	ifTrue:	[^self asLine intersect: (aSegment asLine)]
	ifFalse: [^nil]
! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 6/27/2014 11:48'!
intersectionPointWithLine: aLine

	^ (self asLine intersect: aLine) ifNotNilDo: [ :point | 
		(self hasPoint: point)
			ifTrue:  [ point ]
			ifFalse: [ nil ] ]
! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 7/7/2014 11:32'!
intersectionPointWithRay: ray

	^ (self asLine intersect: ray asLine) ifNotNilDo: [ :point | 
		((self hasPoint: point) and:
				[ray hasPoint: point])
			ifTrue:  [ point ]
			ifFalse: [ nil ] ]
! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 7/2/2014 20:57'!
intersectionPointWithSegment: segm

	^ (self asLine intersect: segm asLine) ifNotNilDo: [ :point | 
		((self hasPoint: point) and:[segm hasPoint: point])
			ifTrue:  [ point ]
			ifFalse: [ nil ] ]
! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 5/15/2014 19:49'!
length
	^ v1 dist: v2! !

!GSegment methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/6/2014 23:47'!
locationOf: aPoint
    
    ^ ((self v2 x - self v1 x) * (aPoint y - self v1 y) - 
      ((self v2 y - self v1 y) * (aPoint x - self v1 x))) signFuz! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 6/28/2014 17:31'!
midPoint
 ^ (v1 + v2) / 2.! !

!GSegment methodsFor: 'properties' stamp: 'NataliaTymchuk 6/11/2014 16:32'!
perpendicularBisector

^GLine
a:  (v2 x - v1 x)
b:  (v2 y - v1 y)
c: ((v1 x * v1 x) - (v2 x * v2 x) + (v1 y * v1 y) - (v2 y * v2 y))/2
! !

!GSegment methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/15/2014 15:25'!
printOn: aStream
	v1 printOn: aStream.
	aStream nextPutAll: '>-<'.
	v2 printOn: aStream! !

!GSegment methodsFor: 'accessing' stamp: 'NataliaTymchuk 5/20/2014 11:05'!
v1
^v1

! !

!GSegment methodsFor: 'accessing' stamp: 'NataliaTymchuk 5/20/2014 11:06'!
v2
^v2

! !

!GSegment methodsFor: 'initialization' stamp: 'NataliaTymchuk 6/15/2014 13:03'!
vertices
	^ { v1 . v2 }! !

Object subclass: #GTriangle
	instanceVariableNames: 'v1 v2 v3 area edgesByOpositeVertex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Geometry'!

!GTriangle commentStamp: 'NataliaTymchuk 5/15/2014 19:07' prior: 0!
I am a triangle!

!GTriangle class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:10'!
with: aPoint1 with: aPoint2 with: aPoint3
	^ self new initializeWith: aPoint1 with: aPoint2 with: aPoint3! !

!GTriangle methodsFor: 'properties' stamp: 'NataliaTymchuk 5/21/2014 12:37'!
area
	| semiperimeter|
	semiperimeter := self semiperimeter.

	^ (self edges 
		inject: semiperimeter
		into: [ :subProduct :edge |
			semiperimeter - edge length * subProduct ]) sqrt! !

!GTriangle methodsFor: 'figures' stamp: 'NataliaTymchuk 5/21/2014 13:03'!
circumscribedCircle

	^ GCircle
		center:
			(self edges first perpendicularBisector intersect:
			 self edges last perpendicularBisector)
		radius: (v1 dist: v2) * (v2 dist: v3) * (v3 dist: v1) / (4 * self area)! !

!GTriangle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 22:13'!
edges
	^ self edgesByOpositeVertex values! !

!GTriangle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/27/2014 23:34'!
edgesByOpositeVertex

	^ edgesByOpositeVertex ifNil: [
		edgesByOpositeVertex := {
			v1 -> (GSegment with: v2 with: v3) .
			v2 -> (GSegment with: v3 with: v1) .
	   		v3 -> (GSegment with: v1 with: v2)  } asDictionary ]! !

!GTriangle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/15/2014 19:09'!
initializeWith: aPoint1 with: aPoint2 with: aPoint3
	super initialize.
	v1 := aPoint1.
	v2 := aPoint2.
	v3 := aPoint3 ! !

!GTriangle methodsFor: 'figures' stamp: 'NataliaTymchuk 6/26/2014 22:00'!
isDegenerate
	^  (self edges first length + self edges second length closeTo: self edges third length) or: [ 
		(self edges second length + self edges third length closeTo: self edges first length) or: [ 
		 self edges third length + self edges first length closeTo: self edges second length ] ]! !

!GTriangle methodsFor: 'properties' stamp: 'NataliaTymchuk 5/15/2014 19:49'!
perimeter
	^ self edges
		inject: 0
		into: [ :subSum :edge |
			subSum + edge length ]! !

!GTriangle methodsFor: 'properties' stamp: 'NataliaTymchuk 5/15/2014 19:50'!
semiperimeter
	^ self perimeter / 2! !

!GTriangle methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 7/5/2014 21:16'!
vertices

	^ { v1 . v2 . v3 }! !

!Object methodsFor: '*geometry' stamp: 'NataliaTymchuk 6/23/2014 18:48'!
<=~ other
	^ self < other or: [ self =~ other ]! !

!Object methodsFor: '*geometry' stamp: 'NataliaTymchuk 6/23/2014 18:48'!
<~ other
	^ (self >=~ other) not! !

!Object methodsFor: '*geometry' stamp: 'NataliaTymchuk 6/23/2014 18:48'!
=~ other
	^ self closeTo: other! !

!Object methodsFor: '*geometry' stamp: 'NataliaTymchuk 6/23/2014 18:48'!
>=~ other
	^ other <=~ self! !

!Object methodsFor: '*geometry' stamp: 'NataliaTymchuk 6/23/2014 18:48'!
>~ other
	^ other <~ self! !
